// ObjRef exporter application.
//
// Mike Woodring & Steve Rodgers
// http://staff.develop.com/woodring
//
using System;
using System.Runtime.Remoting;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Serialization.Formatters.Soap;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Http;
using System.Runtime.Remoting.Channels.Tcp;

public class ObjRefExporter
{
	public static void Main( string[] args )
    {
        bool UseHttp = (args.Length == 0);
        IChannel chan;
        IFormatter formatter;

        if( UseHttp )
        {
            chan = new HttpChannel(999);
            formatter = new SoapFormatter();
        }
        else
        {
            chan = new TcpChannel(999);
            formatter = new BinaryFormatter();
        }

		Cat c = new Cat(189, 122);

		ChannelServices.RegisterChannel(chan);
		ObjRef objref = RemotingServices.Marshal(c);
		FileStream f = new FileStream ("objref.dat", FileMode.Create);

		formatter.Serialize (f, objref);
		f.Close ();

        foreach( string url in ChannelServices.GetUrlsForObject(c) )
        {
            Console.WriteLine(url);
        }

        Console.WriteLine("Exported objref to objref.dat.  Press RETURN to exit.");
        Console.ReadLine();
	}
}
