// ObjRef importer application.
//
// Mike Woodring & Steve Rodgers
// http://staff.develop.com/woodring
//
using System;
using System.Runtime.Remoting;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Serialization.Formatters.Soap;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Http;
using System.Runtime.Remoting.Channels.Tcp;

public class ObjRefImporter
{
	public static void Main( string[] args )
    {
        bool UseHttp = (args.Length == 0);
        IChannel chan;
        IFormatter formatter;

        if( UseHttp )
        {
            chan = new HttpChannel(0);
            formatter = new SoapFormatter();
        }
        else
        {
            chan = new TcpChannel(0);
            formatter = new BinaryFormatter();
        }

		ChannelServices.RegisterChannel(chan);
		FileStream f = new FileStream ("objref.dat", FileMode.Open);

        Dog d = new Dog();

        ObjRef o = (ObjRef) formatter.Deserialize (f);
		ICat c = (ICat) RemotingServices.Unmarshal (o);
		c.Meow (d);
	}
}

public class Dog : MarshalByRefObject, IDog
{
    public void Chase()
    {
        Console.WriteLine("Yipe, yipe, yipe, ...");
    }
}
